/**
 * main.js - kh2Bar HP gauge demonstration
 * Written by: Bruce Pascoe, modified 2013-07-10
**/

RequireScript('kh2Bar.js');

function game()
{
	var colors = [
		CreateColor(0, 255, 0),     // green
		CreateColor(255, 0, 0),     // red
		CreateColor(255, 255, 0),   // yellow
		CreateColor(0, 255, 255),   // cyan
		CreateColor(0, 0, 255),     // blue
		CreateColor(255, 0, 255),   // magenta
		CreateColor(255, 255, 255)  // white
	];
	var colorID = 0
	var font = GetSystemFont();
	var hp = 1025, damage = 0;
	var isHidden = false;
	var lifeBar = new kh2Bar(hp, 100, colors[colorID]);
	
	SetFrameRate(30);
	lifeBar.show();
	var damage = 0;
	while (true) {
		ApplyColorMask(CreateColor(64, 64, 64, 255));
		font.setColorMask(CreateColor(255, 255, 255, 255));
		font.drawText(10, 45, "HP: " + hp);
		font.drawText(100, 40, "press SPACE to deal damage");
		font.drawText(100, 52, "ESC to show or hide the gauge");
		font.drawText(100, 64, "TAB to change color of gauge");
		font.drawText(100, 76, "ENTER to recover all HP");
		if (damage > 0) {
			font.drawText(100, 100, "took " + damage + " damage!");
		}
		lifeBar.draw(160, 10, 150, 12);
		FlipScreen();
		lifeBar.update();
		key = AreKeysLeft() ? GetKey() : null;
		switch (key) {
			case KEY_SPACE:
				damage = Math.floor(Math.random() * 25) + 1;
				hp = Math.max(hp - damage, 0);
				lifeBar.set(hp);
				break;
			case KEY_ENTER:
				damage = 0;
				hp = 1025;
				lifeBar.set(hp)
				break;
			case KEY_ESCAPE:
				isHidden = !isHidden;
				if (!isHidden) {
					lifeBar.show(0.25);
				} else {
					lifeBar.hide(0.25);
				}
				break;
			case KEY_TAB:
				colorID = (colorID + 1) % colors.length;
				lifeBar.changeColor(colors[colorID], 0.25);
				break;
		}
	}
}